diff -ruN vdr-1.7.7/dvbspu.c vdr-1.7.8/dvbspu.c
--- vdr-1.7.7/dvbspu.c	2007-02-03 11:13:18.000000000 +0100
+++ vdr-1.7.8/dvbspu.c	2009-05-09 18:25:59.000000000 +0200
@@ -8,7 +8,7 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.c 2.0 2007/02/03 10:13:18 kls Exp $
+ * $Id: dvbspu.c 2.1 2009/05/09 16:25:59 kls Exp $
  */
 
 #include "dvbspu.h"
@@ -55,18 +55,16 @@
 #define setMin(a, b) if (a > b) a = b
 #define setMax(a, b) if (a < b) a = b
 
-#define spuXres   720
-#define spuYres   576
-
 #define revRect(r1, r2) { r1.x1 = r2.x2; r1.y1 = r2.y2; r1.x2 = r2.x1; r1.y2 = r2.y1; }
 
 cDvbSpuBitmap::cDvbSpuBitmap(sDvbSpuRect size,
                              uint8_t * fodd, uint8_t * eodd,
                              uint8_t * feven, uint8_t * eeven)
 {
-    if (size.x1 < 0 || size.y1 < 0 || size.x2 >= spuXres
-        || size.y2 >= spuYres)
-        throw;
+    size.x1 = max(size.x1, 0);
+    size.y1 = max(size.y1, 0);
+    size.x2 = min(size.x2, Setup.OSDWidth);
+    size.y2 = min(size.y2, Setup.OSDHeight);
 
     bmpsize = size;
     revRect(minsize[0], size);
@@ -74,10 +72,11 @@
     revRect(minsize[2], size);
     revRect(minsize[3], size);
 
-    if (!(bmp = new uint8_t[spuXres * spuYres * sizeof(uint8_t)]))
-        throw;
+    int MemSize = bmpsize.width() * bmpsize.height() * sizeof(uint8_t);
+    bmp = new uint8_t[MemSize];
 
-    memset(bmp, 0, spuXres * spuYres * sizeof(uint8_t));
+    if (bmp)
+       memset(bmp, 0, MemSize);
     putFieldData(0, fodd, eodd);
     putFieldData(1, feven, eeven);
 }
@@ -94,10 +93,10 @@
     int h = size.height();
     int w = size.width();
 
-    if (size.y1 + h >= spuYres)
-        h = spuYres - size.y1 - 1;
-    if (size.x1 + w >= spuXres)
-        w = spuXres - size.x1 - 1;
+    if (size.y1 + h >= bmpsize.height())
+        h = bmpsize.height() - size.y1 - 1;
+    if (size.x1 + w >= bmpsize.width())
+        w = bmpsize.width() - size.x1 - 1;
 
     if (w & 0x03)
         w += 4 - (w & 0x03);
@@ -114,7 +113,7 @@
     // set the content
     for (int yp = 0; yp < h; yp++) {
         for (int xp = 0; xp < w; xp++) {
-            uint8_t idx = bmp[(size.y1 + yp) * spuXres + size.x1 + xp];
+            uint8_t idx = bmp[(size.y1 + yp) * bmpsize.width() + size.x1 + xp];
             ret->SetIndex(xp, yp, idx);
         }
     }
@@ -150,7 +149,7 @@
 
 void cDvbSpuBitmap::putPixel(int xp, int yp, int len, uint8_t colorid)
 {
-    memset(bmp + spuXres * yp + xp, colorid, len);
+    memset(bmp + bmpsize.width() * yp + xp, colorid, len);
     setMin(minsize[colorid].x1, xp);
     setMin(minsize[colorid].y1, yp);
     setMax(minsize[colorid].x2, xp + len - 1);
diff -ruN vdr-1.7.7/dvbspu.h vdr-1.7.8/dvbspu.h
--- vdr-1.7.7/dvbspu.h	2006-04-17 14:47:29.000000000 +0200
+++ vdr-1.7.8/dvbspu.h	2009-05-09 18:26:45.000000000 +0200
@@ -8,7 +8,7 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.h 2.0 2006/04/17 12:47:29 kls Exp $
+ * $Id: dvbspu.h 2.1 2009/05/09 16:26:45 kls Exp $
  */
 
 #ifndef __DVBSPU_H
@@ -32,10 +32,10 @@
     int x1, y1;
     int x2, y2;
 
-    int width() {
+    int width() const {
         return x2 - x1 + 1;
     };
-    int height() {
+    int height() const {
         return y2 - y1 + 1;
     };
 
@@ -63,8 +63,6 @@
 // --- cDvbSpuBitmap----------------------------------------------------------
 
 class cDvbSpuBitmap {
-
-  public:
   private:
     sDvbSpuRect bmpsize;
     sDvbSpuRect minsize[4];
diff -ruN vdr-1.7.7/eit.c vdr-1.7.8/eit.c
--- vdr-1.7.7/eit.c	2009-04-11 12:03:24.000000000 +0200
+++ vdr-1.7.8/eit.c	2009-05-15 14:34:43.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 2.3 2009/04/11 10:03:24 kls Exp $
+ * $Id: eit.c 2.5 2009/05/15 12:34:43 kls Exp $
  */
 
 #include "eit.h"
@@ -17,6 +17,8 @@
 #include "libsi/section.h"
 #include "libsi/descriptor.h"
 
+#define VALID_TIME (31536000 * 2) // two years
+
 // --- cEIT ------------------------------------------------------------------
 
 class cEIT : public SI::EIT {
@@ -46,10 +48,13 @@
   struct tm tm_r;
   struct tm t = *localtime_r(&Now, &tm_r); // this initializes the time zone in 't'
 
+  if (Now < VALID_TIME)
+     return; // we need the current time for handling PDC descriptors
+
   SI::EIT::Event SiEitEvent;
   for (SI::Loop::Iterator it; eventLoop.getNext(SiEitEvent, it); ) {
       bool ExternalData = false;
-      int StartTime = SiEitEvent.getStartTime();
+      time_t StartTime = SiEitEvent.getStartTime();
       int Duration = SiEitEvent.getDuration();
       // Drop bogus events - but keep NVOD reference events, where all bits of the start time field are set to 1, resulting in a negative number.
       if (StartTime == 0 || StartTime > 0 && Duration == 0)
diff -ruN vdr-1.7.7/font.h vdr-1.7.8/font.h
--- vdr-1.7.7/font.h	2009-05-03 13:00:19.000000000 +0200
+++ vdr-1.7.8/font.h	2009-05-23 12:10:40.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: font.h 2.1 2009/05/03 11:00:19 kls Exp $
+ * $Id: font.h 2.2 2009/05/23 10:10:40 kls Exp $
  */
 
 #ifndef __FONT_H
@@ -55,9 +55,11 @@
   static const cFont *GetFont(eDvbFont Font);
           ///< Gets the given Font, which was previously set by a call to SetFont().
           ///< If no SetFont() call has been made, the font as defined in the setup is returned.
-          ///< The caller must not use the returned font outside the scope in which
-          ///< it was retrieved by the call to GetFont(), because a call to SetFont()
-          ///< may delete an existing font.
+          ///< GetFont() is not thread-safe, and shall only be called from the main
+          ///< thread! A font returned by GetFont() must only be used locally inside the
+          ///< function it was retrieved from, and no long term pointer to it shall be kept,
+          ///< because the cFont object may become invalid at any time after the
+          ///< function that called GetFont() has returned.
   static cFont *CreateFont(const char *Name, int CharHeight, int CharWidth = 0);
           ///< Creates a new font object with the given Name and makes its characters
           ///< CharHeight pixels high. If CharWidth is given, it overwrites the font's
diff -ruN vdr-1.7.7/menu.c vdr-1.7.8/menu.c
--- vdr-1.7.7/menu.c	2009-05-03 15:30:13.000000000 +0200
+++ vdr-1.7.8/menu.c	2009-05-21 13:10:38.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.7 2009/05/03 13:30:13 kls Exp $
+ * $Id: menu.c 2.8 2009/05/21 11:10:38 kls Exp $
  */
 
 #include "menu.h"
@@ -2672,18 +2672,24 @@
 // --- cMenuSetupRecord ------------------------------------------------------
 
 class cMenuSetupRecord : public cMenuSetupBase {
+private:
+  const char *pauseKeyHandlingTexts[3];
 public:
   cMenuSetupRecord(void);
   };
 
 cMenuSetupRecord::cMenuSetupRecord(void)
 {
+  pauseKeyHandlingTexts[0] = tr("do not pause live video");
+  pauseKeyHandlingTexts[1] = tr("confirm pause live video");
+  pauseKeyHandlingTexts[2] = tr("pause live video");
   SetSection(tr("Recording"));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Margin at start (min)"),     &data.MarginStart));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Margin at stop (min)"),      &data.MarginStop));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Primary limit"),             &data.PrimaryLimit, 0, MAXPRIORITY));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Default priority"),          &data.DefaultPriority, 0, MAXPRIORITY));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Default lifetime (d)"),      &data.DefaultLifetime, 0, MAXLIFETIME));
+  Add(new cMenuEditStraItem(tr("Setup.Recording$Pause key handling"),        &data.PauseKeyHandling, 3, pauseKeyHandlingTexts));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Pause priority"),            &data.PausePriority, 0, MAXPRIORITY));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Pause lifetime (d)"),        &data.PauseLifetime, 0, MAXLIFETIME));
   Add(new cMenuEditBoolItem(tr("Setup.Recording$Use episode name"),          &data.UseSubtitle));
diff -ruN vdr-1.7.7/osd.c vdr-1.7.8/osd.c
--- vdr-1.7.7/osd.c	2009-05-03 15:52:47.000000000 +0200
+++ vdr-1.7.8/osd.c	2009-05-09 12:42:35.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 2.3 2009/05/03 13:52:47 kls Exp $
+ * $Id: osd.c 2.5 2009/05/09 10:42:35 kls Exp $
  */
 
 #include "osd.h"
@@ -883,7 +883,7 @@
 cOsdProvider *cOsdProvider::osdProvider = NULL;
 int cOsdProvider::oldWidth = 0;
 int cOsdProvider::oldHeight = 0;
-int cOsdProvider::oldAspect = va4_3;
+double cOsdProvider::oldAspect = 1.0;
 
 cOsdProvider::cOsdProvider(void)
 {
@@ -919,13 +919,14 @@
 {
   int Width;
   int Height;
-  eVideoAspect Aspect;
-  cDevice::PrimaryDevice()->GetVideoSize(Width, Height, Aspect);
+  double Aspect;
+  cDevice::PrimaryDevice()->GetOsdSize(Width, Height, Aspect);
   if (Width != oldWidth || Height != oldHeight || Aspect != oldAspect || Force) {
      Setup.OSDLeft = int(round(Width * Setup.OSDLeftP));
      Setup.OSDTop = int(round(Height * Setup.OSDTopP));
      Setup.OSDWidth = int(round(Width * Setup.OSDWidthP)) & ~0x07; // OSD width must be a multiple of 8
      Setup.OSDHeight = int(round(Height * Setup.OSDHeightP));
+     Setup.OSDAspect = Aspect;
      Setup.FontOsdSize = int(round(Height * Setup.FontOsdSizeP));
      Setup.FontFixSize = int(round(Height * Setup.FontFixSizeP));
      Setup.FontSmlSize = int(round(Height * Setup.FontSmlSizeP));
@@ -935,7 +936,7 @@
      oldWidth = Width;
      oldHeight = Height;
      oldAspect = Aspect;
-     dsyslog("OSD size changed to %dx%d @ %s", Width, Height, VideoAspectString[Aspect]);
+     dsyslog("OSD size changed to %dx%d @ %g", Width, Height, Aspect);
      }
 }
 
diff -ruN vdr-1.7.7/osd.h vdr-1.7.8/osd.h
--- vdr-1.7.7/osd.h	2009-05-03 15:52:10.000000000 +0200
+++ vdr-1.7.8/osd.h	2009-05-08 15:41:03.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.h 2.3 2009/05/03 13:52:10 kls Exp $
+ * $Id: osd.h 2.4 2009/05/08 13:41:03 kls Exp $
  */
 
 #ifndef __OSD_H
@@ -408,7 +408,7 @@
   static cOsdProvider *osdProvider;
   static int oldWidth;
   static int oldHeight;
-  static int oldAspect;
+  static double oldAspect;
 protected:
   virtual cOsd *CreateOsd(int Left, int Top, uint Level) = 0;
       ///< Returns a pointer to a newly created cOsd object, which will be located
diff -ruN vdr-1.7.7/osdbase.c vdr-1.7.8/osdbase.c
--- vdr-1.7.7/osdbase.c	2008-02-17 12:33:04.000000000 +0100
+++ vdr-1.7.8/osdbase.c	2009-06-01 13:54:50.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.c 2.0 2008/02/17 11:33:04 kls Exp $
+ * $Id: osdbase.c 2.1 2009/06/01 11:54:50 kls Exp $
  */
 
 #include "osdbase.h"
@@ -217,6 +217,7 @@
          }
      if (current < 0)
         current = 0; // just for safety - there HAS to be a current item!
+     first = min(first, max(0, count - displayMenuItems)); // in case the menu size has changed
      if (current - first >= displayMenuItems || current < first) {
         first = current - displayMenuItems / 2;
         if (first + displayMenuItems > count)
diff -ruN vdr-1.7.7/recorder.c vdr-1.7.8/recorder.c
--- vdr-1.7.7/recorder.c	2009-03-20 16:49:02.000000000 +0100
+++ vdr-1.7.8/recorder.c	2009-05-23 14:18:25.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 2.3 2009/03/20 15:49:02 kls Exp $
+ * $Id: recorder.c 2.4 2009/05/23 12:18:25 kls Exp $
  */
 
 #include "recorder.h"
@@ -44,12 +44,14 @@
      Type = 0x06;
      }
   frameDetector = new cFrameDetector(Pid, Type);
-  patPmtGenerator.SetChannel(Channel);
-  fileName = NULL;
   index = NULL;
   fileSize = 0;
   lastDiskSpaceCheck = time(NULL);
   fileName = new cFileName(FileName, true);
+  int PatVersion, PmtVersion;
+  if (fileName->GetLastPatPmtVersions(PatVersion, PmtVersion))
+     patPmtGenerator.SetVersions(PatVersion + 1, PmtVersion + 1);
+  patPmtGenerator.SetChannel(Channel);
   recordFile = fileName->Open();
   if (!recordFile)
      return;
diff -ruN vdr-1.7.7/recording.c vdr-1.7.8/recording.c
--- vdr-1.7.7/recording.c	2009-04-13 15:50:39.000000000 +0200
+++ vdr-1.7.8/recording.c	2009-06-13 15:34:08.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.12 2009/04/13 13:50:39 kls Exp $
+ * $Id: recording.c 2.16 2009/06/13 13:34:08 kls Exp $
  */
 
 #include "recording.h"
@@ -20,6 +20,7 @@
 #include "channels.h"
 #include "i18n.h"
 #include "interface.h"
+#include "remux.h"
 #include "skins.h"
 #include "tools.h"
 #include "videodir.h"
@@ -622,8 +623,8 @@
      Utf8Strn0Cpy(SubtitleBuffer, Subtitle, MAX_SUBTITLE_LENGTH);
      Subtitle = SubtitleBuffer;
      }
-  char *macroTITLE   = strstr(Timer->File(), TIMERMACRO_TITLE);
-  char *macroEPISODE = strstr(Timer->File(), TIMERMACRO_EPISODE);
+  const char *macroTITLE   = strstr(Timer->File(), TIMERMACRO_TITLE);
+  const char *macroEPISODE = strstr(Timer->File(), TIMERMACRO_EPISODE);
   if (macroTITLE || macroEPISODE) {
      name = strdup(Timer->File());
      name = strreplace(name, TIMERMACRO_TITLE, Title);
@@ -672,7 +673,7 @@
   sortBuffer = NULL;
   fileName = strdup(FileName);
   FileName += strlen(VideoDirectory) + 1;
-  char *p = strrchr(FileName, '/');
+  const char *p = strrchr(FileName, '/');
 
   name = NULL;
   info = new cRecordingInfo;
@@ -1528,8 +1529,8 @@
         if (Independent)
            *Independent = index[Index].independent;
         if (Length) {
-           int fn = index[Index + 1].number;
-           int fo = index[Index + 1].offset;
+           uint16_t fn = index[Index + 1].number;
+           off_t fo = index[Index + 1].offset;
            if (fn == *FileNumber)
               *Length = fo - *FileOffset;
            else
@@ -1559,8 +1560,8 @@
                *FileOffset = index[Index].offset;
                if (Length) {
                   // all recordings end with a non-independent frame, so the following should be safe:
-                  int fn = index[Index + 1].number;
-                  int fo = index[Index + 1].offset;
+                  uint16_t fn = index[Index + 1].number;
+                  off_t fo = index[Index + 1].offset;
                   if (fn == *FileNumber)
                      *Length = fo - *FileOffset;
                   else {
@@ -1629,6 +1630,57 @@
   free(fileName);
 }
 
+bool cFileName::GetLastPatPmtVersions(int &PatVersion, int &PmtVersion)
+{
+  if (fileName && !isPesRecording) {
+     // Find the last recording file:
+     int Number = 1;
+     for (; Number <= MAXFILESPERRECORDINGTS + 1; Number++) { // +1 to correctly set Number in case there actually are that many files
+         sprintf(pFileNumber, RECORDFILESUFFIXTS, Number);
+         if (access(fileName, F_OK) != 0) { // file doesn't exist
+            Number--;
+            break;
+            }
+         }
+     for (; Number > 0; Number--) {
+         // Search for a PAT packet from the end of the file:
+         cPatPmtParser PatPmtParser;
+         sprintf(pFileNumber, RECORDFILESUFFIXTS, Number);
+         int fd = open(fileName, O_RDONLY | O_LARGEFILE, DEFFILEMODE);
+         if (fd >= 0) {
+            off_t pos = lseek(fd, -TS_SIZE, SEEK_END);
+            while (pos >= 0) {
+                  // Read and parse the PAT/PMT:
+                  uchar buf[TS_SIZE];
+                  while (read(fd, buf, sizeof(buf)) == sizeof(buf)) {
+                        if (buf[0] == TS_SYNC_BYTE) {
+                           int Pid = TsPid(buf);
+                           if (Pid == 0)
+                              PatPmtParser.ParsePat(buf, sizeof(buf));
+                           else if (Pid == PatPmtParser.PmtPid()) {
+                              PatPmtParser.ParsePmt(buf, sizeof(buf));
+                              if (PatPmtParser.GetVersions(PatVersion, PmtVersion)) {
+                                 close(fd);
+                                 return true;
+                                 }
+                              }
+                           else
+                              break; // PAT/PMT is always in one sequence
+                           }
+                        else
+                           return false;
+                        }
+                  pos = lseek(fd, pos - TS_SIZE, SEEK_SET);
+                  }
+            close(fd);
+            }
+         else
+            break;
+         }
+     }
+  return false;
+}
+
 cUnbufferedFile *cFileName::Open(void)
 {
   if (!file) {
diff -ruN vdr-1.7.7/recording.h vdr-1.7.8/recording.h
--- vdr-1.7.7/recording.h	2009-04-19 11:00:45.000000000 +0200
+++ vdr-1.7.8/recording.h	2009-05-23 14:14:42.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.7 2009/04/19 09:00:45 kls Exp $
+ * $Id: recording.h 2.8 2009/05/23 12:14:42 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -260,6 +260,7 @@
   ~cFileName();
   const char *Name(void) { return fileName; }
   int Number(void) { return fileNumber; }
+  bool GetLastPatPmtVersions(int &PatVersion, int &PmtVersion);
   cUnbufferedFile *Open(void);
   void Close(void);
   cUnbufferedFile *SetOffset(int Number, off_t Offset = 0);
diff -ruN vdr-1.7.7/remux.c vdr-1.7.8/remux.c
--- vdr-1.7.7/remux.c	2009-05-03 16:43:25.000000000 +0200
+++ vdr-1.7.8/remux.c	2009-06-06 15:24:57.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.20 2009/05/03 14:43:25 kls Exp $
+ * $Id: remux.c 2.24 2009/06/06 13:24:57 kls Exp $
  */
 
 #include "remux.h"
@@ -357,6 +357,12 @@
      }
 }
 
+void cPatPmtGenerator::SetVersions(int PatVersion, int PmtVersion)
+{
+  patVersion = PatVersion & 0x1F;
+  pmtVersion = PmtVersion & 0x1F;
+}
+
 void cPatPmtGenerator::SetChannel(cChannel *Channel)
 {
   if (Channel) {
@@ -383,8 +389,9 @@
 
 // --- cPatPmtParser ---------------------------------------------------------
 
-cPatPmtParser::cPatPmtParser(void)
+cPatPmtParser::cPatPmtParser(bool UpdatePrimaryDevice)
 {
+  updatePrimaryDevice = UpdatePrimaryDevice;
   Reset();
 }
 
@@ -472,7 +479,8 @@
      dbgpatpmt("     pcr = %d\n", Pmt.getPCRPid());
      if (pmtVersion == Pmt.getVersionNumber())
         return;
-     cDevice::PrimaryDevice()->ClrAvailableTracks(false, true);
+     if (updatePrimaryDevice)
+        cDevice::PrimaryDevice()->ClrAvailableTracks(false, true);
      int NumApids = 0;
      int NumDpids = 0;
      int NumSpids = 0;
@@ -481,6 +489,7 @@
      for (SI::Loop::Iterator it; Pmt.streamLoop.getNext(stream, it); ) {
          dbgpatpmt("     stream type = %02X, pid = %d", stream.getStreamType(), stream.getPid());
          switch (stream.getStreamType()) {
+           case 0x01: // STREAMTYPE_11172_VIDEO
            case 0x02: // STREAMTYPE_13818_VIDEO
            case 0x1B: // MPEG4
                       vpid = stream.getPid();
@@ -515,7 +524,8 @@
                                }
                              delete d;
                              }
-                         cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, NumApids, stream.getPid(), ALangs);
+                         if (updatePrimaryDevice)
+                            cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, NumApids, stream.getPid(), ALangs);
                          NumApids++;
                          }
                       }
@@ -550,7 +560,8 @@
                                               break;
                                            }
                                         }
-                                    cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, NumSpids, stream.getPid(), SLangs);
+                                    if (updatePrimaryDevice)
+                                       cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, NumSpids, stream.getPid(), SLangs);
                                     NumSpids++;
                                     }
                                  break;
@@ -566,7 +577,8 @@
                           }
                       if (dpid) {
                          if (NumDpids < MAXDPIDS) {
-                            cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, NumDpids, dpid, lang);
+                            if (updatePrimaryDevice)
+                               cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, NumDpids, dpid, lang);
                             NumDpids++;
                             }
                          }
@@ -574,8 +586,10 @@
                       break;
            }
          dbgpatpmt("\n");
-         cDevice::PrimaryDevice()->EnsureAudioTrack(true);
-         cDevice::PrimaryDevice()->EnsureSubtitleTrack();
+         if (updatePrimaryDevice) {
+            cDevice::PrimaryDevice()->EnsureAudioTrack(true);
+            cDevice::PrimaryDevice()->EnsureSubtitleTrack();
+            }
          }
      pmtVersion = Pmt.getVersionNumber();
      }
@@ -584,13 +598,19 @@
   pmtSize = 0;
 }
 
+bool cPatPmtParser::GetVersions(int &PatVersion, int &PmtVersion)
+{
+  PatVersion = patVersion;
+  PmtVersion = pmtVersion;
+  return patVersion >= 0 && pmtVersion >= 0;
+}
+
 // --- cTsToPes --------------------------------------------------------------
 
 cTsToPes::cTsToPes(void)
 {
   data = NULL;
   size = length = offset = 0;
-  synced = false;
 }
 
 cTsToPes::~cTsToPes()
@@ -702,7 +722,7 @@
   newFrame = independentFrame = false;
   numPtsValues = 0;
   numIFrames = 0;
-  isVideo = type == 0x02 || type == 0x1B; // MPEG 2 or MPEG 4
+  isVideo = type == 0x01 || type == 0x02 || type == 0x1B; // MPEG 1, 2 or 4
   frameDuration = 0;
   framesInPayloadUnit = framesPerPayloadUnit = 0;
   payloadUnitOfFrame = 0;
@@ -795,6 +815,7 @@
                   scanner <<= 8;
                   scanner |= Data[i];
                   switch (type) {
+                    case 0x01: // MPEG 1 video
                     case 0x02: // MPEG 2 video
                          if (scanner == 0x00000100) { // Picture Start Code
                             if (synced && Processed)
diff -ruN vdr-1.7.7/remux.h vdr-1.7.8/remux.h
--- vdr-1.7.7/remux.h	2009-04-19 12:57:09.000000000 +0200
+++ vdr-1.7.8/remux.h	2009-06-06 15:26:23.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 2.10 2009/04/19 10:57:09 kls Exp $
+ * $Id: remux.h 2.17 2009/06/06 13:26:23 kls Exp $
  */
 
 #ifndef __REMUX_H
@@ -181,6 +181,15 @@
        ///< with GetPmt().
 public:
   cPatPmtGenerator(cChannel *Channel = NULL);
+  void SetVersions(int PatVersion, int PmtVersion);
+       ///< Sets the version numbers for the generated PAT and PMT, in case
+       ///< this generator is used to, e.g.,  continue a previously interrupted
+       ///< recording (in which case the numbers given should be derived from
+       ///< the PAT/PMT versions last used in the existing recording, incremented
+       ///< by 1. If the given numbers exceed the allowed range of 0..31, the
+       ///< higher bits will automatically be cleared.
+       ///< SetVersions() needs to be called before SetChannel() in order to
+       ///< have an effect from the very start.
   void SetChannel(cChannel *Channel);
        ///< Sets the Channel for which the PAT/PMT shall be generated.
   uchar *GetPat(void);
@@ -204,10 +213,11 @@
   int pmtPid;
   int vpid;
   int vtype;
+  bool updatePrimaryDevice;
 protected:
   int SectionLength(const uchar *Data, int Length) { return (Length >= 3) ? ((int(Data[1]) & 0x0F) << 8)| Data[2] : 0; }
 public:
-  cPatPmtParser(void);
+  cPatPmtParser(bool UpdatePrimaryDevice = false);
   void Reset(void);
        ///< Resets the parser. This function must be called whenever a new
        ///< stream is parsed.
@@ -221,6 +231,9 @@
        ///< are delivered to the parser through several subsequent calls to
        ///< ParsePmt(). The whole PMT data will be processed once the last packet
        ///< has been received.
+  bool GetVersions(int &PatVersion, int &PmtVersion);
+       ///< Returns true if a valid PAT/PMT has been parsed and stores
+       ///< the current version numbers in the given variables.
   int PmtPid(void) { return pmtPid; }
        ///< Returns the PMT pid as defined by the current PAT.
        ///< If no PAT has been received yet, -1 will be returned.
@@ -239,7 +252,6 @@
   int size;
   int length;
   int offset;
-  bool synced;
 public:
   cTsToPes(void);
   ~cTsToPes();
@@ -249,11 +261,24 @@
        ///< If the given TS packet starts a new PES payload packet, the converter
        ///< will be automatically reset. Any packets before the first one that starts
        ///< a new PES payload packet will be ignored.
+       ///< Once a TS packet has been put into a cTsToPes converter, all subsequent
+       ///< packets until the next call to Reset() must belong to the same PID as
+       ///< the first packet. There is no check whether this actually is the case, so
+       ///< the caller is responsible for making sure this condition is met.
   const uchar *GetPes(int &Length);
        ///< Gets a pointer to the complete PES packet, or NULL if the packet
        ///< is not complete yet. If the packet is complete, Length will contain
        ///< the total packet length. The returned pointer is only valid until
        ///< the next call to PutTs() or Reset(), or until this object is destroyed.
+       ///< Once GetPes() has returned a non-NULL value, it must be called
+       ///< repeatedly, and the data processed, until it returns NULL. This
+       ///< is because video packets may be larger than the data a single
+       ///< PES packet with an actual length field can hold, and are therefore
+       ///< split into several PES packets with smaller sizes.
+       ///< Note that for video data GetPes() may only be called if the next
+       ///< TS packet that will be given to PutTs() has the "payload start" flag
+       ///< set, because this is the only way to determine the end of a video PES
+       ///< packet.
   void Reset(void);
        ///< Resets the converter. This needs to be called after a PES packet has
        ///< been fetched by a call to GetPes(), and before the next call to
diff -ruN vdr-1.7.7/ringbuffer.c vdr-1.7.8/ringbuffer.c
--- vdr-1.7.7/ringbuffer.c	2009-02-24 12:32:14.000000000 +0100
+++ vdr-1.7.8/ringbuffer.c	2009-05-17 12:05:17.000000000 +0200
@@ -7,7 +7,7 @@
  * Parts of this file were inspired by the 'ringbuffy.c' from the
  * LinuxDVB driver (see linuxtv.org).
  *
- * $Id: ringbuffer.c 2.1 2009/02/24 11:32:14 kls Exp $
+ * $Id: ringbuffer.c 2.2 2009/05/17 10:05:17 kls Exp $
  */
 
 #include "ringbuffer.h"
@@ -43,7 +43,7 @@
 {
   if (Fill > maxFill)
      maxFill = Fill;
-  int percent = Fill * 100 / (Size() - 1) / PERCENTAGEDELTA * PERCENTAGEDELTA;
+  int percent = Fill * 100 / (Size() - 1) / PERCENTAGEDELTA * PERCENTAGEDELTA; // clamp down to nearest quantum
   if (percent != lastPercent) {
      if (percent >= PERCENTAGETHRESHOLD && percent > lastPercent || percent < PERCENTAGETHRESHOLD && lastPercent >= PERCENTAGETHRESHOLD) {
         dsyslog("buffer usage: %d%% (tid=%d)", percent, getThreadTid);
diff -ruN vdr-1.7.7/skins.c vdr-1.7.8/skins.c
--- vdr-1.7.7/skins.c	2008-02-17 12:31:09.000000000 +0100
+++ vdr-1.7.8/skins.c	2009-06-06 17:12:31.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skins.c 2.0 2008/02/17 11:31:09 kls Exp $
+ * $Id: skins.c 2.1 2009/06/06 15:12:31 kls Exp $
  */
 
 #include "skins.h"
@@ -78,8 +78,9 @@
   tabs[3] = Tab3 ? tabs[2] + Tab3 : 0;
   tabs[4] = Tab4 ? tabs[3] + Tab4 : 0;
   tabs[5] = Tab5 ? tabs[4] + Tab5 : 0;
+  int AvgCharWidth = Setup.FontOsdSize * 3 / 5; // just an estimate
   for (int i = 1; i < MaxTabs; i++)
-      tabs[i] *= 12;//XXX average character width of font used for items - see also skincurses.c!!!
+      tabs[i] *= AvgCharWidth;
 }
 
 void cSkinDisplayMenu::Scroll(bool Up, bool Page)
diff -ruN vdr-1.7.7/svdrp.c vdr-1.7.8/svdrp.c
--- vdr-1.7.7/svdrp.c	2009-04-13 15:35:29.000000000 +0200
+++ vdr-1.7.8/svdrp.c	2009-06-06 16:03:55.000000000 +0200
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.3 2009/04/13 13:35:29 kls Exp $
+ * $Id: svdrp.c 2.5 2009/06/06 14:03:55 kls Exp $
  */
 
 #include "svdrp.h"
@@ -739,7 +739,7 @@
      char *strtok_next;
      FileName = strtok_r(p, delim, &strtok_next);
      // image type:
-     char *Extension = strrchr(FileName, '.');
+     const char *Extension = strrchr(FileName, '.');
      if (Extension) {
         if (strcasecmp(Extension, ".jpg") == 0 || strcasecmp(Extension, ".jpeg") == 0)
            Jpeg = true;
@@ -798,16 +798,17 @@
      char RealFileName[PATH_MAX];
      if (FileName) {
         if (grabImageDir) {
-           cString s;
-           char *slash = strrchr(FileName, '/');
+           cString s(FileName);
+           FileName = s;
+           const char *slash = strrchr(FileName, '/');
            if (!slash) {
               s = AddDirectory(grabImageDir, FileName);
               FileName = s;
               }
            slash = strrchr(FileName, '/'); // there definitely is one
-           *slash = 0;
-           char *r = realpath(FileName, RealFileName);
-           *slash = '/';
+           cString t(s);
+           t.Truncate(slash - FileName);
+           char *r = realpath(t, RealFileName);
            if (!r) {
               LOG_ERROR_STR(FileName);
               Reply(501, "Invalid file name \"%s\"", FileName);
diff -ruN vdr-1.7.7/tools.c vdr-1.7.8/tools.c
--- vdr-1.7.7/tools.c	2009-01-16 15:29:08.000000000 +0100
+++ vdr-1.7.8/tools.c	2009-05-31 13:43:24.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 2.2 2009/01/16 14:29:08 kls Exp $
+ * $Id: tools.c 2.3 2009/05/31 11:43:24 kls Exp $
  */
 
 #include "tools.h"
@@ -1473,16 +1473,18 @@
 
 int cUnbufferedFile::Close(void)
 {
-#ifdef USE_FADVISE
   if (fd >= 0) {
+#ifdef USE_FADVISE
      if (totwritten)    // if we wrote anything make sure the data has hit the disk before
         fdatasync(fd);  // calling fadvise, as this is our last chance to un-cache it.
      posix_fadvise(fd, 0, 0, POSIX_FADV_DONTNEED);
-     }
 #endif
-  int OldFd = fd;
-  fd = -1;
-  return close(OldFd);
+     int OldFd = fd;
+     fd = -1;
+     return close(OldFd);
+     }
+  errno = EBADF;
+  return -1;
 }
 
 // When replaying and going e.g. FF->PLAY the position jumps back 2..8M
